// GSphere origin --> GG.scene();
// origin.color( Color.RED );
// origin.sca( 0.1 );

Keyboard keyboard; 
spork ~ keyboard.listener();

GG.scene() @=> GScene @ scene;

// GOrbitCamera cam --> scene;
// scene.camera( cam );
// // cam.orthographic();


// GFlyCamera fly_cam --> GG.scene();
// GG.scene().camera(fly_cam);

// GG.camera().viewSize( viewSize );
// GG.camera().pos( @(0, 2, viewSize) );



Texture.load(
    me.dir() + "textures/beige.jpg", // right
    me.dir() + "textures/beige.jpg", // left
    me.dir() + "textures/beige.jpg", // top
    me.dir() + "textures/beige.jpg", // bottom
    me.dir() + "textures/beige.jpg", // back
    me.dir() + "textures/beige.jpg"  // front
) @=> Texture cubemap;




// Texture.load(
//     me.dir() + "skybox/posx.jpg", // right
//     me.dir() + "skybox/negx.jpg", // left
//     me.dir() + "skybox/posy.jpg", // top
//     me.dir() + "skybox/negy.jpg", // bottom
//     me.dir() + "skybox/posz.jpg", // back
//     me.dir() + "skybox/negz.jpg"  // front
// ) @=> Texture cubemap;

GG.scene().envMap(cubemap);


// GG.scene().ambient( @(0,0,0) );

// GG.scene().backgroundColor(@(1,1,1)*1.5); // IMPORTANT!!! Final color skybox *times* background color
GG.fps( 80 );



// GCube xaxis --> scene;
// xaxis.scaX( 1000 );
// xaxis.color( Color.RED );



// bloom
GG.renderPass() --> BloomPass bloom_pass --> GG.outputPass();
bloom_pass.input( GG.renderPass().colorOutput() );
GG.outputPass().input( bloom_pass.colorOutput() );

bloom_pass.intensity(0.9);
bloom_pass.radius(0.4);
bloom_pass.levels(9);
// bloom_pass.threshold(3);




GPointLight light --> scene;
light.color( @(1,1,1) * 1.5 );
light.pos( @(0, 20, 0) );
light.intensity(2.0);
light.radius(25);

// global float volume;
// UI_Float inputVolume(volume);
// fun void ui() {
//     while (true) {
//         GG.nextFrame() => now;
//         UI.setNextWindowSize(@(400, 200), UI_Cond.Once);
//         if (UI.begin("blow some bubbles", null, 0)) {

//             UI.slider("input volume", inputVolume, 0.0, 10.0);

//         }
//         UI.end();
//     }
// } spork ~ ui();




// Bubble bubbles[100];
// for (0 => int i; i < 100; i++) {
//     bubbles[i] --> scene;
//     bubbles[i].pos( @(Math.random2f(-50, 50), Math.random2f(10, 100), Math.random2f(-50, 50)) );
//     bubbles[i].sca( Math.random2f(0.5, 1.5) );
//     bubbles[i].detachFromWand();
// }



Texture.load(me.dir() + "textures/swirl.png") @=> Texture swirl;
PhongMaterial groundMat;
// groundMat.color( @(0.75,1,0.9)*2 );
groundMat.color( @(0.75,1,0.9)*5 );
// groundMat.colorMap(swirl);

GCircle ground --> scene;
ground.mat( groundMat );
ground.sca( 200 );
ground.pos( @(0, 0, 0) );
ground.rotX( -Math.PI/2.0 );
// ground.color( @(0,1,0.6)*2 );



-9.8 => global float gravity;


GG.scene().backgroundColor( @(1,1,1)*5 );
// GG.scene().backgroundColor( @(0,0,0.0025) );
fun void bgColorChange() {
    1250 => int numFrames;
    float t;
    while (true) {
        GG.nextFrame() => now;
        if (keyboard.tab) {
            for (int i; i < numFrames; i++) {
                GG.nextFrame() => now;
                (i/(numFrames - 1)$float) => t;
                GG.scene().backgroundColor( (@(1 - Math.pow( t, 1/5.0),1 - Math.pow( t, 1/4.0),1.002 - Math.pow( t, 1/3.0))) * 5 );
                Math.map2(i, 0, numFrames, -9.8, 2*9.8) => gravity;
            }
            break;
        } 
    }
} 
spork ~ bgColorChange();

// GCylinder cylinder --> scene;
// cylinder.pos( @(1, 0, 1) );
// cylinder.sca( @(0.01, 100, 0.01) );
// cylinder.color( Color.RED*1000 );\

fun void highFrequency() {
    Envelope eSin => dac;
    SinOsc sin1 => eSin;
    SinOsc sin2 => eSin;
    eSin.duration(1000::ms);
    10000 => sin1.freq;
    9000 => sin2.freq;
    0.1 => sin1.gain;
    0.1 => sin2.gain;

    eSin.keyOn();
    while (true) {
        GG.nextFrame() => now;
    }
}

fun void end() {
    100 => int numFrames;
    float t;
    while (true) {
        GG.nextFrame() => now;
        if (keyboard.P) {
            spork ~ highFrequency();

            ground.detach();

            for (int i; i < numFrames; i++) {
                GG.nextFrame() => now;
                (i/(numFrames - 1)$float) => t;
                GG.scene().backgroundColor( (@(0,0,.002) + t * @(1,1,1)* 5 ));
            }

            

            while (true) {
                GG.nextFrame() => now;
            }
        } 
    }
} 
spork ~ end();

// fun void gravityDirection() {
//     while (true) {
//         GG.nextFrame() => now;
//         if (keyboard.G) {
//             -1 * gravity => gravity;
//             <<< "gravity direction changed" >>>;
//             for (int i; i < 100; i++) {
//                 GG.nextFrame() => now;
//             }
//         } 
//     }
// } spork ~ gravityDirection();


while (true) {

    GG.nextFrame() => now;

    UI.setMouseCursor(UI_MouseCursor.None);
}





